@echo off
REM ############################################################
REM ## Copyright (c) 2007-2010 - OpenSmartHome.com - WOSH
REM ## All rights reserved.
REM ##  open source, founded by Alessandro Polo
REM ##  http://www.OpenSmartHome.com
REM ##  http://www.AlessandroPolo.name
REM ############################################################
REM ## This script creates distribution packages for Windows
REM ## 
REM ############################################################
REM #                                              CONFIGURATION

set ROOT=..
cd %ROOT%

set TARGET=%1
set VERSION=%2


set VERSION=2010-01-25

if "%TARGET%"=="" set TARGET=all

set DEST=distr\WOSH-%VERSION%


REM ############################################################
set DOXYGEN_BIN=doxygen.exe
set DOXYGEN_DIR=G:\Program Files\doxygen
set PATH=%DOXYGEN_DIR%\bin;%PATH%
REM ############################################################
set SVN_BIN=svn.exe
set SVN_DIR=G:\Program Files\Subversion\
set PATH=%SVN_DIR%\bin;%PATH%
REM ############################################################
set COMPRESS_BIN=winzip32.exe -min -a -r
set COMPRESS_DIR=G:\Program Files\WinZip
set PATH=%COMPRESS_DIR%;%PATH%
REM ############################################################

%TARGET%=all


:selection
if "%TARGET%"=="all" goto all
if "%TARGET%"=="bin" goto bin
if "%TARGET%"=="doc" goto doc
if "%TARGET%"=="src" goto src
if "%TARGET%"=="full" goto full

goto noparam

REM #                                              CONFIGURATION
REM ############################################################

REM ############################################################
REM #                                                        ALL
:all
echo Building ALL..
echo.

REM ############################################################
REM ############################################################
REM #                                               REQUIRED DLL
:copydll
echo Copying QT DLL(s) (such as %QTDIR_WIN32%\lib\QtCore4.dll)
echo.
REM ## release DLL
copy %QTDIR_WIN32%\lib\QtCore4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtNetwork4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtXml4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtSql4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtGui4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\phonon4.dll bin\ > NUL
REM ## debug DLL
copy %QTDIR_WIN32%\lib\QtCored4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtNetworkd4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtXmld4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtSqld4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\QtGuid4.dll bin\ > NUL
copy %QTDIR_WIN32%\lib\phonond4.dll bin\ > NUL
if "%TARGET%"=="msi" goto msi2
if "%TARGET%"=="copydll" goto end
REM #                                               REQUIRED DLL


REM #                                                        MSI
:msi
echo Building WOSH Installer package (msi).. [\build\msi-package\WoshInstaller.vdproj]
echo.

:msi2
echo.
echo  Creating MSI package..
%DEVENV% %DEVENV_OPT% build\msi-package\WoshInstaller.vdproj
if not "%TARGET%"=="all" goto end
REM #                                                        MSI


REM #                                                        ALL
REM ############################################################



REM ############################################################
REM #                                                        DOC
:doc
echo Building Documentation [%DEST%]
echo.
cd doc
REM %DOXYGEN_BIN% Doxyfile
cd ..
if "%TARGET%"=="doc" goto end
REM #                                                        DOC
REM ############################################################

REM ############################################################
REM #                                                        BIN
:bin
echo Building Binary distribution [%DEST%]
echo  Creating ZIP package..
echo.

if "%TARGET%"=="bin" goto end
REM #                                                        BIN
REM ############################################################

REM ############################################################
REM #                                                     SOURCE
:src
echo Exporting SubVersion Filesystem to %DEST%
echo.
REM %SVN_BIN% export . %DEST%
if "%TARGET%"=="src" goto end
REM #                                                     SOURCE
REM ############################################################

REM ############################################################
REM #                                                       FULL
:src
echo Copying Binaries..
cd bin
xcopy *.exe ..\%DEST%\bin\ /E /Y /I
xcopy *.dll ..\%DEST%\bin\ /E /Y /I
xcopy woshcesrv\*.exe ..\%DEST%\bin\woshcesrv\ /E /Y /I
xcopy woshcesrv\*.dll ..\%DEST%\bin\woshcesrv\ /E /Y /I
cd ..
echo.
echo Copying Documentation..
mkdir %DEST%\doc\html\
cd doc
xcopy .\html\*.* ..\%DEST%\doc\html\ /E /Y /I
cd ..
echo.
if "%TARGET%"=="src" goto end
REM #                                                       FULL
REM ############################################################


echo.
echo  Compressing %DEST% to WOSH-full-%VERSION%.zip
%COMPRESS_BIN% WOSH-full-%VERSION%.zip %DEST%
echo.
if exist "distr\WoshInstaller.msi" (
	echo  Renaming WoshInstaller.msi as WOSH-bin-win32-%VERSION%.msi
	move distr\WoshInstaller.msi distr\WOSH-bin-win32-%VERSION%.msi
)

REM ############################################################
REM ############################################################
:end
echo.
echo All Done.
pause
exit 0
pause
REM ############################################################
REM #                                                       MENU
:menu
echo Choose Distribution TARGET: {all,bin,full}
echo.
:choice
SET /P TARGET=[all,bin,full]?
goto selection
REM ############################################################
:noparam
echo.
echo ERROR: Missing or invalid TARGET.
echo.
echo  Usage:
echo   distr.bat TARGET {all,bin,full} VERSION_NUMBER
echo.
pause
exit 1
