@echo off
REM ############################################################
REM ## Copyright (c) 2007-2010 - OpenSmartHome.com - WOSH
REM ## All rights reserved.
REM ##  open source, founded by Alessandro Polo
REM ##  http://www.OpenSmartHome.com
REM ##  http://www.AlessandroPolo.name
REM ############################################################
REM ## This script (re)builds WOSH Applications
REM ## Requirements:
REM ##  - MinGW 4.4 (included in QT installation)
REM ##  - QT 4.4 (or later) built (locally) for Windows
REM ##    Define 'QTDIR_WINGW' in your environment settings.
REM ############################################################
REM #                                              CONFIGURATION

set ROOT=..

if "%QTDIR_WINGW%"=="" (
	echo Setting DEFAULT option of QTDIR_WINGW = G:\dev\Qt\2010.01
	set QTDIR_WINGW=G:\dev\Qt\2010.01
)

if exist "%QTDIR_WINGW%\mingw\bin" (
	set MINGW=%QTDIR_WINGW%\mingw\bin
)

if not exist "%MINGW%\mingw\bin"=="" (
	echo Setting DEFAULT option of QTDIR_WINGW = G:\dev\Qt\2010.01
	set QTDIR_WINGW=G:\dev\Qt\2010.01
)


:config
REM ############################################################

if exist "%QTDIR_WINGW%\bin\qtenv.bat" call "%QTDIR_WINGW%\bin\qtenv.bat" 

REM ############################################################
:devenv

set DEVENV=mingw32-make

set DEVENV_OPT=
REM #    /clean

REM #                                              CONFIGURATION
REM ############################################################
:bootscript

cd %ROOT%

REM ############################################################
echo.
echo WOSH Framework 2010
echo ===================
REM ############################################################

set TARGET=%1
if "%TARGET%"=="" goto menu

set OPTION=%2
if "%OPTION%"=="" goto menu2

REM ############################################################
:selection
if "%TARGET%"=="all" goto all
if "%TARGET%"=="woshsrv" goto woshsrv
if "%TARGET%"=="woshshop" goto woshshop
if "%TARGET%"=="woshremote" goto woshremote
if "%TARGET%"=="woshkiosk" goto woshkiosk
if "%TARGET%"=="copydll" goto copydll
goto noparam

REM ############################################################
REM ############################################################
REM #                                                        ALL
:all
echo Building ALL..
echo.

REM #                                                        ALL
REM ############################################################

REM ############################################################
REM #                                                    WOSHSRV
:woshsrv
echo Building WOSH Server.. [\src\apps\woshsrv]
set PATH=%QTDIR_WINGW%\bin;%PATH%
echo  Creating project.. [\src\woshsrv.pro]
cd src
qmake woshsrv.pro -unix
cd ..
echo.
if not "%OPTION%"=="nopause" pause
if not "%OPTION%"=="qmake-only" (
	echo.
	echo  Building solution..
	cd src
	%DEVENV% %DEVENV_OPT%
	cd ..
 )
if not "%TARGET%"=="all" goto end
REM #                                                    WOSHSRV
REM ############################################################
REM #                                                   WOSHSHOP
:woshshop
echo Building WOSH WorkShop.. [\src\apps\woshshop]
set PATH=%QTDIR_WINGW%\bin;%PATH%
echo  Creating project.. [\src\woshshop.pro]
cd src
qmake woshshop.pro
cd ..
echo.
if not "%OPTION%"=="nopause" pause
if not "%OPTION%"=="qmake-only" (
	echo.
	echo  Building solution..
	cd src
	%DEVENV% %DEVENV_OPT%
	cd ..
 )
if not "%TARGET%"=="all" goto end
REM #                                                   WOSHSHOP
REM ############################################################
REM #                                                 WOSHREMOTE
:woshremote
echo Building WOSH Remote.. [\src\apps\woshremote]
set PATH=%QTDIR_WINGW%\bin;%PATH%
echo  Creating project.. [\src\woshremote.pro]
cd src
qmake woshremote.pro
cd ..
echo.
if not "%OPTION%"=="nopause" pause
if not "%OPTION%"=="qmake-only" (
	echo.
	echo  Building solution..
	cd src
	%DEVENV% %DEVENV_OPT%
	cd ..
 )
if not "%TARGET%"=="all" goto end
REM #                                                 WOSHREMOTE
REM ############################################################

REM ############################################################

goto end

REM ############################################################
REM #                                                  WOSHKIOSK
:woshkiosk
echo Building WOSH Remote.. [\src\apps\woshkiosk]
set PATH=%QTDIR_WINGW%\bin;%PATH%
echo  Creating project.. [\src\woshkiosk.pro]
cd src
qmake woshkiosk.pro
cd ..
echo.
if not "%OPTION%"=="nopause" pause
if not "%OPTION%"=="qmake-only" (
	echo.
	echo  Building solution..
	cd src
	%DEVENV% %DEVENV_OPT%
	cd ..
 )
if not "%TARGET%"=="all" goto end
REM #                                                  WOSHKIOSK
REM ############################################################

REM ############################################################
REM #                                                      CLEAN



REM #                                                      CLEAN
REM ############################################################

goto end

REM ############################################################
REM #                                                  QT SELECT
:select_qtwin32
echo PATH of QT for Win32-MinGW (%QTDIR_WINGW%) is invalid!
echo.
goto end
REM #                                                  QT SELECT
REM ############################################################
REM #                                                       MENU
:menu
echo  Choose Building TARGET:
:choice
SET /P TARGET=[all,woshsrv,woshshop,woshremote,woshkiosk]?
if "%OPTION%"=="" goto menu2
goto selection
REM ############################################################
:menu2
echo  Choose Building OPTION:
:choice2
SET /P OPTION=[qmake-only,none]?
goto selection
REM ############################################################
:noparam
echo.
echo ERROR: Missing or invalid TARGET.
echo.
echo  Usage:
echo   make_msvc.bat TARGET {all,woshsrv,woshshop,woshremote,woshkiosk} OPTION(s)
echo.
if not "%OPTION%"=="nopause" pause
exit 1
REM ############################################################
:end
echo.
echo All Done.
pause
echo.
