@echo off
REM ############################################################
REM ## Copyright (c) 2007-2010 - OpenSmartHome.com - WOSH
REM ## All rights reserved.
REM ##  open source, founded by Alessandro Polo
REM ##  http://www.OpenSmartHome.com
REM ##  http://www.AlessandroPolo.name
REM ############################################################
REM ## This script (re)builds WOSH Applications
REM ## Requirements:
REM ##  - Microsoft Visual Studio 2005-2008 (8.0,9.0)
REM ##  - QT 4.4 (or later) built (locally) for Windows
REM ##    Define 'QTDIR_WIN32' in your environment settings.
REM ############################################################
REM #                                              CONFIGURATION

set ROOT=..

if "%QTDIR_WIN32%"=="" (
	echo Setting DEFAULT option of QTDIR_WIN32 = G:\dev\Qt\win32.4.6.1
	set QTDIR_WIN32=G:\dev\Qt\win32.4.6.1
)


:config
REM ############################################################

if exist "%QTDIR_WIN32%\bin\qtenv.bat" call "%QTDIR_WIN32%\bin\qtenv.bat" 

if not "%VSINSTALLDIR%"=="" goto devenv

if not "%VS80COMNTOOLS%"=="" call "%VS80COMNTOOLS%vsvars32.bat"
if not "%VS90COMNTOOLS%"=="" call "%VS90COMNTOOLS%vsvars32.bat"

REM ############################################################
:devenv

if exist "%VS80COMNTOOLS%..\IDE\VCExpress.*" set DEVENV="%VS80COMNTOOLS%..\IDE\VCExpress"
if exist "%VS90COMNTOOLS%..\IDE\VCExpress.*" set DEVENV="%VS90COMNTOOLS%..\IDE\VCExpress"

if exist "%VS80COMNTOOLS%..\IDE\devenv.*" set DEVENV="%VS80COMNTOOLS%..\IDE\devenv"
if exist "%VS90COMNTOOLS%..\IDE\devenv.*" set DEVENV="%VS90COMNTOOLS%..\IDE\devenv"

set DEVENV_OPT=/nologo /rebuild Debug
REM #    /clean

REM #                                              CONFIGURATION
REM ############################################################
:bootscript

cd %ROOT%

REM ############################################################
echo.
echo WOSH Framework 2010
echo ===================
REM ############################################################

set TARGET=%1
if "%TARGET%"=="" goto menu

set OPTION=%2
if "%OPTION%"=="" goto menu2

REM ############################################################
:selection
if "%TARGET%"=="all" goto all
if "%TARGET%"=="woshsrv" goto woshsrv
if "%TARGET%"=="woshshop" goto woshshop
if "%TARGET%"=="woshremote" goto woshremote
if "%TARGET%"=="woshkiosk" goto woshkiosk
if "%TARGET%"=="testsuite" goto testsuite
if "%TARGET%"=="copydll" goto copydll
goto noparam

REM ############################################################
REM ############################################################
REM #                                                        ALL
:all
echo Building ALL..
echo.

REM #                                                        ALL
REM ############################################################

REM ############################################################
REM #                                                    WOSHSRV
:woshsrv
echo Building WOSH Server.. [\src\apps\woshsrv]
set PATH=%QTDIR_WIN32%\bin;%PATH%
echo  Creating project.. [\src\woshsrv.pro]
cd src
%QTDIR_WIN32%\bin\qmake woshsrv.pro -t vcapp
cd ..
echo.
if not "%OPTION%"=="nopause" pause
if not "%OPTION%"=="qmake" (
	echo.
	echo  Building solution.. [\src\woshsrv.vcproj]
	cd src
	%DEVENV% %DEVENV_OPT% woshsrv.vcproj
	cd ..
 )
if not "%TARGET%"=="all" goto end
REM #                                                    WOSHSRV
REM ############################################################
REM #                                                   WOSHSHOP
:woshshop
echo Building WOSH WorkShop.. [\src\apps\woshshop]
set PATH=%QTDIR_WIN32%\bin;%PATH%
echo  Creating project.. [\src\woshshop.pro]
cd src
%QTDIR_WIN32%\bin\qmake woshshop.pro -t vcapp
cd ..
echo.
if not "%OPTION%"=="nopause" pause
if not "%OPTION%"=="qmake" (
	echo.
	echo  Building solution.. [\src\woshshop.vcproj]
	cd src
	%DEVENV% %DEVENV_OPT% woshshop.vcproj
	cd ..
 )
if not "%TARGET%"=="all" goto end
REM #                                                   WOSHSHOP
REM ############################################################
REM #                                                 WOSHREMOTE
:woshremote
echo Building WOSH Remote.. [\src\apps\woshremote]
set PATH=%QTDIR_WIN32%\bin;%PATH%
echo  Creating project.. [\src\woshremote.pro]
cd src
%QTDIR_WIN32%\bin\qmake woshremote.pro -t vcapp
cd ..
echo.
if not "%OPTION%"=="nopause" pause
if not "%OPTION%"=="qmake" (
	echo.
	echo  Building solution.. [\src\woshremote.vcproj]
	cd src
	%DEVENV% %DEVENV_OPT% woshremote.vcproj
	cd ..
 )
if not "%TARGET%"=="all" goto end
REM #                                                 WOSHREMOTE
REM ############################################################

REM ############################################################
REM #                                                  WOSHKIOSK
:woshkiosk
echo Building WOSH Remote.. [\src\apps\woshkiosk]
set PATH=%QTDIR_WIN32%\bin;%PATH%
echo  Creating project.. [\src\woshkiosk.pro]
cd src
%QTDIR_WIN32%\bin\qmake woshkiosk.pro -t vcapp
cd ..
echo.
if not "%OPTION%"=="nopause" pause
if not "%OPTION%"=="qmake" (
	echo.
	echo  Building solution.. [\src\woshkiosk.vcproj]
	cd src
	%DEVENV% %DEVENV_OPT% woshkiosk.vcproj
	cd ..
 )
if not "%TARGET%"=="all" goto end
REM #                                                  WOSHKIOSK
REM ############################################################

REM ############################################################
REM #                                                  TESTSUITE
:testsuite
echo Building WOSH Remote.. [\src\testsuite]
set PATH=%QTDIR_WIN32%\bin;%PATH%
echo  Creating project.. [\src\testsuite\dsm\dsm.pro]
cd src
%QTDIR_WIN32%\bin\qmake dsm.pro -t vcapp
cd ..
echo.

if not "%TARGET%"=="all" goto end
REM #                                                  TESTSUITE
REM ############################################################

REM ############################################################
REM #                                                      CLEAN



REM #                                                      CLEAN
REM ############################################################

goto end

REM ############################################################
REM #                                                  QT SELECT
:select_qtwin32
echo PATH of QT for Win32 (%QTDIR_WIN32%) is invalid!
echo.
goto end
REM #                                                  QT SELECT
REM ############################################################
REM #                                                       MENU
:menu
echo  Choose Building TARGET:
:choice
SET /P TARGET=[all,woshsrv,woshshop,woshremote,woshkiosk,testsuite]?
if "%OPTION%"=="" goto menu2
goto selection
REM ############################################################
:menu2
echo  Choose Building OPTION:
:choice2
SET /P OPTION=[qmake,nopause,none]?
goto selection
REM ############################################################
:noparam
echo.
echo ERROR: Missing or invalid TARGET.
echo.
echo  Usage:
echo   make_msvc.bat TARGET {all,woshsrv,woshshop,woshremote,woshkiosk,testsuite} OPTION(s)
echo.
if not "%OPTION%"=="nopause" pause
exit 1
REM ############################################################
:end
echo.
echo All Done.
pause
echo.
