@echo off
REM ############################################################
REM ## Copyright (c) 2007-2010 - OpenSmartHome.com - WOSH
REM ## All rights reserved.
REM ##  open source, founded by Alessandro Polo
REM ##  http://www.OpenSmartHome.com
REM ##  http://www.AlessandroPolo.name
REM ############################################################
REM ## This script (re)builds WOSH CE SERVER
REM ## Requirements:
REM ##  - Microsoft Visual Studio 2005-2008 (8.0,9.0)
REM ##  - Microsoft Windows Mobile 6.0 SDK
REM ##  - QT 4.1 (or later) built (locally) for Windows CE
REM ##    Define 'QTDIR_WINCE' in your environment settings.
REM ############################################################
REM #                                              CONFIGURATION

set ROOT=..


if "%QTDIR_WINCE%"=="" (
	set QTDIR_WINCE=G:\dev\Qt\wince.4.6.1
)
if not exist "%QTDIR_WINCE%" goto qtdir_error

:config
REM ############################################################

if not "%VSINSTALLDIR%"=="" goto devenv

if not "%VS80COMNTOOLS%"=="" call "%VS80COMNTOOLS%vsvars32.bat"
if not "%VS90COMNTOOLS%"=="" call "%VS90COMNTOOLS%vsvars32.bat"

REM ############################################################
:devenv

if exist "%VS80COMNTOOLS%..\IDE\VCExpress.*" set DEVENV="%VS80COMNTOOLS%..\IDE\VCExpress"
if exist "%VS90COMNTOOLS%..\IDE\VCExpress.*" set DEVENV="%VS90COMNTOOLS%..\IDE\VCExpress"

if exist "%VS80COMNTOOLS%..\IDE\devenv.*" set DEVENV="%VS80COMNTOOLS%..\IDE\devenv"
if exist "%VS90COMNTOOLS%..\IDE\devenv.*" set DEVENV="%VS90COMNTOOLS%..\IDE\devenv"

set DEVENV_OPT=/nologo /rebuild Debug

REM #                                              CONFIGURATION
REM ############################################################
:bootscript

cd %ROOT%

set OPTION=%1

:selection
REM ############################################################
echo.
echo WOSH Framework 2010
echo ===================
REM ############################################################
REM #                                          WOSHCESRV - QMAKE
:qmake
echo Creating Project file for WOSH CE Server.. [\src\woshcesrv.pro => \src\woshcesrv.vcproj]
echo  Configuring environment.. [wincewm60standard-msvc2008]
echo.
call %QTDIR_WINCE%\bin\setcepaths.bat wincewm60standard-msvc2008
echo.
echo  Executing Qmake.. 
cd src
%QTDIR_WINCE%\bin\qmake woshcesrv.pro -t vcapp
cd ..
echo.
REM #                                          WOSHCESRV - QMAKE
REM ############################################################
if not "%OPTION%"=="nopause" (
	pause
	echo.
)
REM ############################################################
REM #                                        WOSHCESRV - VCBUILD
:vcbuild
echo Building WOSH CE Server.. [\src\woshcesrv.vcproj]
if not exist ".\src\woshcesrv.vcproj" (
	echo Project file '\src\woshcesrv.vcproj' is missing, generating..
	goto qmake
)
cd src
%DEVENV% %DEVENV_OPT% woshcesrv.vcproj
cd ..
REM #                                        WOSHCESRV - VCBUILD
REM ############################################################




REM ############################################################
REM #                                           WOSHCESRV - DLLs
echo  Copying QT DLL(s) (such as %QTDIR_WINCE%\lib\QtCore4.dll)
echo.
REM ## release DLL
copy %QTDIR_WINCE%\lib\QtCore4.dll bin\woshcesrv\ > NUL
copy %QTDIR_WINCE%\lib\QtNetwork4.dll bin\woshcesrv\ > NUL
copy %QTDIR_WINCE%\lib\QtXml4.dll bin\woshcesrv\ > NUL
REM ## debug DLL
copy %QTDIR_WINCE%\lib\QtCored4.dll bin\woshcesrv\ > NUL
copy %QTDIR_WINCE%\lib\QtNetworkd4.dll bin\woshcesrv\ > NUL
copy %QTDIR_WINCE%\lib\QtXmld4.dll bin\woshcesrv\ > NUL
REM #                                           WOSHCESRV - DLLs
REM ############################################################

goto end

REM ############################################################
REM #                                                  QT SELECT
:qtdir_error
echo PATH of QT for WinCE (%QTDIR_WINCE%) is missing/invalid!
echo Pelase define 'QTDIR_WINCE' in your environment settings.
echo.
pause
goto end
REM #                                                  QT SELECT
REM ############################################################
REM #                                                       MENU

if not "%OPTION%"=="nopause" pause
exit 1
REM ############################################################
:end
echo.
echo All Done.
pause
echo.
