/**
 * @class   IVGettyAMListener
 * @brief   Interface for VGettyAMImpl callbacks (events).
 *
 * @see     VGettyAMImpl
 * @see     wosh::devices::VGettyAMBundle
 ****************************************************************************
 * @version $Id: IVGettyAMListener.h 2025 2010-03-03 19:47:55Z alex $
 * @author  Alessandro Polo
 * @date    Released on 2009-06-04
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_DEVICES_IVGettyAMListener_H__
 #define __WOSH_DEVICES_IVGettyAMListener_H__

 #include <string>


class VGettyAMImpl;
namespace wosh {
 namespace communication {
   class AudioMessage;
 };
};

class IVGettyAMListener  {

	public:
		virtual void incoming_DTMF( int line, const std::string& sequence, VGettyAMImpl* source ) = 0;
		virtual void incoming_Message( int line, const wosh::communication::AudioMessage* message, VGettyAMImpl* source ) = 0;
		virtual void phone_event( int line, int event, VGettyAMImpl* source ) = 0;

	public:
		virtual ~IVGettyAMListener() { }

}; // class def


#endif //__WOSH_DEVICES_IVGettyAMListener_H__
