# QMAKE Configuration file
# Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
# by Alessandro Polo - OpenSmartHome.com
# All rights reserved.
#######################################################
# Revision $Id: Festival.pro 1708 2010-01-26 22:28:01Z alex $
#######################################################

CONFIG += console rtti stl exceptions thread moc
QT -= gui

DEPENDPATH += .
INCLUDEPATH += . ../../../

OBJECTS_DIR = ../../../../tmp/Festival

INCLUDEPATH += /usr/include/speech_tools
LIBS += -lFestival
LIBS += -lncurses
LIBS += -lesd -lestools -lestbase -leststring

HEADERS += bundles/services/Festival/FestivalBundle.h
SOURCES += bundles/services/Festival/FestivalBundle.cpp

HEADERS += bundles/services/Festival/FestivalImpl.h
SOURCES += bundles/services/Festival/FestivalImpl.cpp

########################################################################
CONFIG += make_lib_static
#CONFIG += make_lib_shared
#CONFIG += make_plugin
#CONFIG += make_app_test
########################################################################


########################################################################
############################################################# LIB STATIC
make_lib_static  {
	message("WOSH Framework - Festival - LIB STATIC")

	TEMPLATE = lib
	CONFIG += staticlib
	TARGET = bundleFestival
	DESTDIR = ../../../../lib

}
########################################################################
############################################################# LIB SHARED
make_lib_shared {
	message("WOSH Framework - Festival - LIB SHARED")

	TEMPLATE = lib
	TARGET = bundleFestival
	DESTDIR = ../../../../lib

}
########################################################################
################################################################# PLUGIN
make_plugin {
	message("WOSH Framework - Festival - PLUGIN")

	TEMPLATE = lib
	TARGET = plugin_FestivalBundle
	DESTDIR = ../../../../bin

	SOURCES += plugin_FestivalBundle.cpp

}
########################################################################
########################################################################
############################################################### APP TEST
make_app_test {
	message("WOSH Framework - Festival - APP TEST")

	TEMPLATE = app
	TARGET = test_Festival
	DESTDIR = ../../../../bin

	LIBS += -L../../../../lib
	LIBS += -lcore

	HEADERS -= FestivalBundle.h
	SOURCES -= FestivalBundle.cpp

	SOURCES += test_Festival.cpp

}
########################################################################
