/**
 * @class   FestivalImpl
 * @brief   
 *
 *
 *
 *
 *
 ****************************************************************************
 * @version $Id: FestivalImpl.h 2065 2010-03-09 21:59:05Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Services_FestivalImpl_H__
 #define __WOSH_Services_FestivalImpl_H__

 #include <core/BundleGenericWorker.h>
 #include <core/Containers.h>
 #include <core/MessageQueue.h>

 #include <framework/communication/TextMessage.h>
 #include <framework/communication/AudioMessage.h>
 #include <framework/communication/NotificationConversion.h>


using namespace wosh;
using namespace wosh::communication;


class FestivalJob {

	public:
		FestivalJob() {
			this->conversion = NULL;
		 }
		virtual ~FestivalJob() { }

	public:
		NotificationConversion* conversion;
		URI requestSource;

		std::string festivalCommand;

};

typedef List22<FestivalJob*> tFestivalJobList;

class FestivalImpl : public BundleGenericWorker  {

	public:

		/**
		 * @brief   Default constructor. Init vars.
		 */
		FestivalImpl( BundleGeneric& bundle );

		/**
		 * @brief   Deconstructor. If thread is stll running, it will be stopped.
		 */
		virtual ~FestivalImpl();


	public:

		void enqueue( FestivalJob* job );

		void processJob( FestivalJob* job );

//@}
/** @name Setters
 * @{
 ******************************************************************************/
	public:

	

//@}
/** @name Getters
 * @{
 ******************************************************************************/
	public:


//@}
/** @name Internal methods
 * @{
 ******************************************************************************/
	protected:

		void processJobConversion( NotificationConversion* conversion, const URI& requestSource );
		void processJobConfiguration( const std::string& command, const URI& requestSource );

		WRESULT execFestivalCommand( const std::string& command );

		/**
		 * @brief   
		 * @see     running
		 * @see     
		 */
		virtual void runThread();

//@}

		tFestivalJobList jobs;


}; // class def


#endif //__WOSH_Services_FestivalImpl_H__
