/**
 * @class   wosh::HumanInterpreter
 * @brief   
 *
 *INPUT:	MESSAGGIO
	-> parsing
	-> valutazione
	
	-> generazione messaggi(o) -> FINE
	-> generazione messaggi(o) [wait] EVAL RESPONSE, syntetize REPLY
	
	esempio usa AIML BOT e/o inference engine
	
	
	
	
		-> GESTISCE e REGISTRA UN PROTOCOL !
 *
 * \section Internet resources
 * 
 *   - http://www.lsi.upc.edu/~nlp/freeling/ [FreeLing: tokenizer, morphological analysis]
 *   - http://multiwordnet.fbk.eu/online/multiwordnet.php [Italian multilingual lexical database] (not free!)
 *
 *
 *
 ****************************************************************************
 * @version	$Id: HumanInterpreterBundle.h 1948 2010-02-25 00:18:29Z alex $
 * @author	Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Bundles_Services_HumanInterpreter_H__
 #define __WOSH_Bundles_Services_HumanInterpreter_H__

 #include <core/BundleGeneric.h>
 #include <core/Thread.h>

 #include <core/Notification.h>
 #include <core/Communicator.h>

 #include <framework/communication/NotificationConversion.h>

 #include <interfaces/Service.h>
 #include <interfaces/services/InterpreterService.h>
 #include <interfaces/services/HumanInterpreter.h>

 #include "SessionProtocolHuman.h"

class FreeLingImpl;

using namespace std;
using namespace wosh::communication;
namespace wosh {
 namespace services {

 #define _HumanInterpreter_NAME				"HumanInterpreter"
 #define _HumanInterpreter_VERSION			"0.6"


class HumanInterpreterBundle :	public BundleGeneric,
								public virtual wosh::interfaces::services::InterpreterService,
								public virtual wosh::interfaces::services::HumanInterpreter
 {
	WOSH_BUNDLE(wosh::services::HumanInterpreterBundle)
	WOSH_BUNDLE_INTERFACE("wosh::services::HumanInterpreter")

	public:

		HumanInterpreterBundle();

		virtual ~HumanInterpreterBundle();


/** @name Bundle Interface
 * @{
 ******************************************************************************/
	public:
		virtual WRESULT bundleStart();
		virtual WRESULT bundleStop();

		virtual void busMessage( const Message& message, const Bus* source );

	public:

	
/** @name HumanInterpreter Interface
 * @{
 ******************************************************************************/
	public:

		Notification* translate( const NotificationConversion* conversion );

		bool validateTranslation( const NotificationConversion* conversion );

		WRESULT enqueueTranslation( const NotificationConversion* conversion, const URI* uri );

//@}
/** @name Getters
 * @{
 ******************************************************************************/
 	public:

//@}
/** @name Modem Events
 * @{
 ******************************************************************************/
 	protected:

	//	WRESULT translateHumanToShell( const string& input_english, string& output_shell );
	//	WRESULT translateShellToHuman( const string& input_shell, string& output_english );

//@}
/** @name Internal methods
 * @{
 ******************************************************************************/
	protected:

		Response* mmDoConvert( const Message* requestMessage );


//@}

	protected:

		FreeLingImpl* autoWorker;	///< real implementation


}; // class def

 }; // namespace services
}; // namespace wosh

#endif //__WOSH_Bundles_Services_HumanInterpreter_H__
