# QMAKE Configuration file
# Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
# by Alessandro Polo - OpenSmartHome.com
# All rights reserved.
#######################################################
# Revision $Id: Organizer.pro 1708 2010-01-26 22:28:01Z alex $
#######################################################

CONFIG += console rtti stl exceptions thread moc
QT -= gui

DEPENDPATH += .
INCLUDEPATH += . ../../../

OBJECTS_DIR = ../../../../tmp/Organizer

INCLUDEPATH += /usr/include
LIBS += -L/usr/lib
LIBS += -lgloox

HEADERS += OrganizerToDo.h
SOURCES += OrganizerToDo.cpp

HEADERS += OrganizerSchedule.h
HEADERS += IOrganizerListener.h

HEADERS += OrganizerImpl.h
SOURCES += OrganizerImpl.cpp

HEADERS += OrganizerBundle.h
SOURCES += OrganizerBundle.cpp


########################################################################
# custom building setting (will override)
!include( ../services.pri ) {
	message( "*****  No custom build options specified. *****" )
	message( "*****  Building Bundles - Services - Organizer TEST *****" )
	#CONFIG += make_app_test
} 

#CONFIG += make_lib_static
#CONFIG += make_lib_shared
#CONFIG += make_plugin
#CONFIG += make_app_test
########################################################################


########################################################################
############################################################# LIB STATIC
make_lib_static  {
	message("WOSH Framework - Bundles - Services - Organizer - LIB STATIC")

	TEMPLATE = lib
	CONFIG += staticlib
	TARGET = bundleOrganizer
	DESTDIR = ../../../../lib

}
########################################################################
############################################################# LIB SHARED
make_lib_shared {
	message("WOSH Framework - Bundles - Services - Organizer - LIB SHARED")

	TEMPLATE = lib
	TARGET = bundleOrganizer
	DESTDIR = ../../../../lib

}
########################################################################
################################################################# PLUGIN
make_plugin {
	message("WOSH Framework - Bundles - Services - Organizer - PLUGIN")

	TEMPLATE = lib
	TARGET = plugin_OrganizerBundle
	DESTDIR = ../../../../bin

	SOURCES += plugin_OrganizerBundle.cpp

}
########################################################################
########################################################################
############################################################### APP TEST
make_app_test {
	message("WOSH Framework - Bundles - Services - Organizer - APP TEST")

	TEMPLATE = app
	TARGET = test_Organizer
	DESTDIR = ../../../../bin

	LIBS += -L../../../../lib
	LIBS += -lcore

	HEADERS -= OrganizerBundle.h
	SOURCES -= OrganizerBundle.cpp

	SOURCES += test_Organizer.cpp

}
########################################################################
