# QMAKE Configuration file
# Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
# by Alessandro Polo - OpenSmartHome.com
# All rights reserved.
#######################################################
# Revision $Id: SessionServer.pro 1708 2010-01-26 22:28:01Z alex $
#######################################################

CONFIG += console rtti stl exceptions thread moc
QT -= gui

DEPENDPATH += .
INCLUDEPATH += . ../../../

OBJECTS_DIR = ../../../../tmp/SessionServer

INCLUDEPATH += /usr/include
LIBS += -L/usr/lib
LIBS += -lgloox

HEADERS += SessionServerImpl.h
SOURCES += SessionServerImpl.cpp

HEADERS += ISessionServerListener.h

HEADERS += SessionServerBundle.h
SOURCES += SessionServerBundle.cpp


########################################################################
# custom building setting (will override)
!include( ../services.pri ) {
	message( "*****  No custom build options specified. *****" )
	message( "*****  Building Bundles - Services - SessionServer TEST *****" )
	#CONFIG += make_app_test
} 

#CONFIG += make_lib_static
#CONFIG += make_lib_shared
#CONFIG += make_plugin
#CONFIG += make_app_test
########################################################################


########################################################################
############################################################# LIB STATIC
make_lib_static  {
	message("WOSH Framework - Bundles - Services - SessionServer - LIB STATIC")

	TEMPLATE = lib
	CONFIG += staticlib
	TARGET = bundleSessionServer
	DESTDIR = ../../../../lib

}
########################################################################
############################################################# LIB SHARED
make_lib_shared {
	message("WOSH Framework - Bundles - Services - SessionServer - LIB SHARED")

	TEMPLATE = lib
	TARGET = bundleSessionServer
	DESTDIR = ../../../../lib

}
########################################################################
################################################################# PLUGIN
make_plugin {
	message("WOSH Framework - Bundles - Services - SessionServer - PLUGIN")

	TEMPLATE = lib
	TARGET = plugin_SessionServerBundle
	DESTDIR = ../../../../bin

	SOURCES += plugin_SessionServerBundle.cpp

}
########################################################################
########################################################################
############################################################### APP TEST
make_app_test {
	message("WOSH Framework - Bundles - Services - SessionServer - APP TEST")

	TEMPLATE = app
	TARGET = test_SessionServer
	DESTDIR = ../../../../bin

	LIBS += -L../../../../lib
	LIBS += -lcore

	HEADERS -= SessionServerBundle.h
	SOURCES -= SessionServerBundle.cpp

	SOURCES += test_SessionServer.cpp

}
########################################################################
