
#ifndef SUN_STUFF_H
 #define SUN_STUFF_H

 #include <ctime>
 #include <cmath>
 #include <string>
 #include <string.h>


using namespace std;

 #ifndef M_PI
   #define M_PI 3.14159265358979323846
 #endif

 #define M_RADS			(M_PI/180.0)
 #define M_DEGS			(180.0/M_PI)

 // Sunradius degrees
 #define SUN_RADIUS_D	0.53

 // athmospheric refraction degrees
 #define AIR_REFR		34.0/60.0
 
double FNsun (double d);
double FNday (int y, int m, int d, float h);
double FNrange (double x);
double f0(double lat, double declin);
double f1(double lat, double declin);
double FNsun (double d, double& L, double& g);


void calculateSunTimes(
							const double& latitude, const double& longitude, const double& timezone,
							double& riset,
							double& settm,
							double& twam,
							double& twpm,
							double& daylen,
							double& noont,
							double& altmax,
							double& declin
							);


void dHour2TM(double dhr, struct tm& time_out);
string TM2Time(const struct tm& tim);


#endif
