# QMAKE Configuration file
# Copyright (c) 2007-2009, WOSH - Wide Open Smart Home 
# by Alessandro Polo - OpenSmartHome.com
# All rights reserved.
#######################################################
# Revision $Id: common.pri 2186 2010-03-21 01:50:49Z alex $
#######################################################

message( SYSTEM - Qt version: $$[QT_VERSION])
message( SYSTEM - Qt is installed in $$[QT_INSTALL_PREFIX])
message( SYSTEM - Header files: $$[QT_INSTALL_HEADERS])
message( SYSTEM - Libraries: $$[QT_INSTALL_LIBS])
 
#####################################################
# shared configuration options
#
CONFIG += rtti stl exceptions thread moc
DESTDIR = ../bin
OBJECTS_DIR = ../tmp
MOC_DIR = ../tmp/moc
UI_DIR = ../tmp/ui
RCC_DIR = ../tmp/rcc

#####################################################
# disable QT gui by default, when WOSH_GUI is set
# it will be included by sub-project files
#
QT -= gui

#####################################################
# some more common defines
#
DEPENDPATH += .
INCLUDEPATH += .
LIBS += -L../lib/
LIBS += -L../lib/3rdparty
INCLUDEPATH += ../lib/3rdparty

unix {
	INCLUDEPATH += /usr/include
	LIBS += -L../lib
	LIBS += -L/usr/lib
}

#####################################################
# global defines
#
unix	{	DEFINES += _OS_POSIX }
win32	{	DEFINES += _OS_WIN32 }
winCE	{
	DEFINES -= _OS_WIN32
	DEFINES += _OS_WINCE
 }

#####################################################
# include WOSH basic headers
#
HEADERS += woshDefs.h
HEADERS += woshConfig.h

#####################################################
# custom building setting (will override)
#
!exists( custom.pri ) {
	message( "*****  No custom.pri build options specified. *****" )
} 

#####################################################
# include WOSH Core
#
!include( core/core.pro ) {
	error( "*****  No core/core.pro file found. *****" )
	message( "*****  FAILED *****" )
} 
#####################################################
# include WOSH Interfaces, they are abstract classes,
# without external dependencies
#
!include( interfaces/interfaces.pro ) {
	error( "*****  No interfaces/interfaces.pro file found. *****" )
	message( "*****  FAILED *****" )
} 
