/**
 * @class   wosh::DataBase
 * @brief   
 *
 ****************************************************************************
 * @version $Id: DataBase.h 2015 2010-03-02 23:57:45Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Core_DataBase_H__
 #define __WOSH_Core_DataBase_H__

 #include <core/Object.h>
 #include <core/Utilities.h>

 #include <vector>


namespace wosh {

 #define _DataBase_TYPE					"wosh::DataBase"


#undef WOSH_DATABASE
#define WOSH_DATABASE(CLASSNAME)				\
		WOSH_CLASSNAME(CLASSNAME)				\
		WOSH_CLASS_ABSTRACT(false)



class DataBase : public Object
 {
	WOSH_CLASSNAME(wosh::DataBase)
	WOSH_CLASS_ABSTRACT(true)

	public:

		virtual WRESULT loadObjects( std::vector<ISerializable*>& objects, const std::string& class_name, const std::string& archive_name ) = 0;

		virtual WRESULT saveObjects( std::vector<ISerializable*>& objects, const std::string& archive_name ) = 0;

		virtual std::string getProtocol() const = 0;

	public:
		DataBase() : Object() {
			Object::setName( "DataBase", Utilities::randomLong() );
		 }

		virtual ~DataBase() { }

}; // class def


}; // namespace wosh

#endif //__WOSH_Core_DataBase_H__
