
/*

To construct the solution in an optimal way. Algorithm maintains two sets. One contains chosen items and the other contains rejected items.

The greedy algorithm consists of four (4) function.

   1. A function that checks whether chosen set of items provide a solution.
   2. A function that checks the feasibility of a set.
   3. The selection function tells which of the candidates is the most promising.
   4. An objective function, which does not appear explicitly, gives the value of a solution.


*  Initially the set of chosen items is empty i.e., solution set.
* At each step
	  o item will be added in a solution set by using selection function.
	  o IF the set would no longer be feasible
			+ reject items under consideration (and is never consider again).
	  o ELSE IF set is still feasible THEN
			+ add the current item.

A feasible set (of candidates) is promising if it can be extended to produce not merely a solution, but an optimal solution to the problem. In particular, the empty set is always promising why? (because an optimal solution always exists)

Unlike Dynamic Programming, which solves the subproblems bottom-up, a greedy strategy usually progresses in a top-down fashion, making one greedy choice after another, reducing each problem to a smaller one. 






*/