/** @file    EncoderXMLCommon.cpp
 *  @author  Alessandro Polo
 *  @version $Id: EncoderXMLCommon.cpp 1827 2010-02-12 18:12:21Z alex $
 *  @brief
 * File containing methods for Serialization.
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

 #include <framework/database/EncoderXMLCommon.h>
 #include <framework/database/CoderXML_Core.h>

#ifdef WOSH_AUTOMATIONS
# include <framework/database/CoderXML_Automations.h>
#endif

#ifdef WOSH_BUILDING
# include <framework/database/CoderXML_Building.h>
#endif

#ifdef WOSH_COMMUNICATION
# include <framework/database/CoderXML_Communication.h>
#endif

#ifdef WOSH_ENTERTAINMENT
# include <framework/database/CoderXML_Entertainment.h>
#endif

#ifdef WOSH_SECURITY
# include <framework/database/CoderXML_Security.h>
#endif

#ifdef WOSH_XTENDED
# include <framework/database/CoderXML_Xtended.h>
#endif


using namespace std;
namespace wosh {
 namespace database {


void EncoderXML_register_default_types()
 {
	EncoderXML_register_Core();

#ifdef WOSH_AUTOMATIONS
	EncoderXML_register_Automations();
#endif

#ifdef WOSH_BUILDING
	EncoderXML_register_Buildings();
#endif

#ifdef WOSH_COMMUNICATION
	EncoderXML_register_Communication();
#endif

#ifdef WOSH_ENTERTAINMENT
	EncoderXML_register_Entertainment();
#endif

#ifdef WOSH_SECURITY
	EncoderXML_register_Security();
 #endif

#ifdef WOSH_XTENDED
	EncoderXML_register_Xtended();
#endif

}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////

 }; // namespace database
}; // namespace wosh
