/**
 * @class   wosh::database::EncoderSQL_base
 * @brief   
 * 
 ****************************************************************************
 * @class   wosh::database::EncoderSQL_template
 * @brief   
 * 
 * 
 ****************************************************************************
 * @version $Id: SerializableSQL.h 1968 2010-02-27 05:52:38Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR BusS;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_SerializationSQL_H__
 #define __WOSH_SerializationSQL_H__

 #include <woshDefs.h>
 #include <core/Serialization.h>

 #include <QtSql>


namespace wosh {
 namespace database {


class EncoderSQL_base {
	public:
		virtual ISerializable* allocObject() = 0;

		virtual WRESULT serializeTo( const ISerializable* object, QSqlQuery& query ) = 0;
		virtual WRESULT deserializeFrom( ISerializable* object, const QSqlQuery& query ) = 0;

	public:
		virtual ~EncoderSQL_base() { }

};




template <class T>
class EncoderSQL_template : public EncoderSQL_base  {
	public:

	//	virtual WRESULT serializeTo( const T* object, QDomDocument& doc, QDomElement& contNode, bool compact ) = 0;
	//	virtual WRESULT deserializeFrom( T* object, const QDomElement& contNode ) = 0;

	public:
		virtual ~EncoderSQL_template() { }
		EncoderSQL_template() : EncoderSQL_base() { }

};

 }; // namespace database
}; // namespace wosh

#endif //__WOSH_SerializationSQL_H__
