/**
 * @class   wosh::gui::LogHandlerQRenderer
 * @brief   
 *          
 *          
 *
 ****************************************************************************
 * @version $Id: LogHandlerQRenderer.h 2170 2010-03-18 22:05:00Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Gui_LogHandlerQRenderer_H__
# define __WOSH_Gui_LogHandlerQRenderer_H__

 #include <core/LogContext.h>
 #include <core/LogHandlers.h>
 #include <QObject>


namespace Ui {
 class FormLogViewer;
};
namespace wosh {
 namespace gui {


class LogHandlerQRenderer : public QObject, public LogHandler
 {
	Q_OBJECT

	public:
		LogHandlerQRenderer( QObject* parent = NULL )
			: QObject(parent), LogHandler(), printColoured(false) { }

		virtual ~LogHandlerQRenderer() {
			close();
		 }

	public:
		virtual WRESULT open();
		virtual WRESULT close();
		virtual WRESULT flush() { return WRET_OK; }
		virtual bool isOpen() const;

		virtual std::string getProtocol() const {
			MutexLockerRead mL(&this->configMux);
			return Utilities::format("QWidget://%s", this->objectName().toLatin1().data());
		 }

		// really-multithread safe
		virtual void log( const char* context, LogLevel level, const char* format, va_list args );

	public:
		void setColoured( bool enabled = true );

	protected:
		bool printColoured;
		char* buffer;

	signals:
		void appendLine( const QString& message );


}; // class def

 }; // namespace gui
}; // namespace wosh


#endif // __WOSH_Gui_LogHandlerQRenderer_H__
