# QMAKE Configuration file
# Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
# by Alessandro Polo - OpenSmartHome.com
# All rights reserved.
#######################################################
# Revision $Id: gui.pro 2221 2010-03-26 18:32:14Z alex $
#######################################################

message( "WOSH - FRAMEWORK [GUI]" )

DEFINES += WOSH_GUI
QT += gui

RESOURCES += framework/gui/gui.qrc


HEADERS += framework/gui/BuildingObjectGraphicsItem.h
SOURCES += framework/gui/BuildingObjectGraphicsItem.cpp

HEADERS += framework/gui/BusConnectorQt.h
SOURCES += framework/gui/BusConnectorQt.cpp

HEADERS += framework/gui/BusRingQt.h
SOURCES += framework/gui/BusRingQt.cpp

HEADERS += framework/gui/DialogCreateGui.h
FORMS   += framework/gui/DialogCreateGui.ui

FORMS   += framework/gui/DialogGuiMapping.ui

HEADERS += framework/gui/DialogLoadBundle.h
FORMS   += framework/gui/DialogLoadBundle.ui

HEADERS += framework/gui/LogHandlerQRenderer.h
SOURCES += framework/gui/LogHandlerQRenderer.cpp

HEADERS += framework/gui/WoshTreeModel.h

HEADERS += framework/gui/FormBundle.h
SOURCES += framework/gui/FormBundle.cpp
FORMS   += framework/gui/FormBundle.ui


HEADERS += framework/gui/FormBusViewer.h
SOURCES += framework/gui/FormBusViewer.cpp
FORMS   += framework/gui/FormBusViewer.ui


HEADERS += framework/gui/FormConsole.h
SOURCES += framework/gui/FormConsole.cpp
FORMS   += framework/gui/FormConsole.ui

HEADERS += framework/gui/FormContainer.h

HEADERS += framework/gui/FormLogViewer.h
SOURCES += framework/gui/FormLogViewer.cpp
FORMS   += framework/gui/FormLogViewer.ui


#######################################################

HEADERS += framework/gui/GuiCache.h
SOURCES += framework/gui/GuiCache.cpp
HEADERS += framework/gui/GuiDialogs.h
SOURCES += framework/gui/GuiDialogs.cpp
HEADERS += framework/gui/GuiUtilities.h
SOURCES += framework/gui/GuiUtilities.cpp

#######################################################

HEADERS += framework/gui/IWidget.h
SOURCES += framework/gui/IWidget.cpp

HEADERS += framework/gui/IWidgetSerializable.h

HEADERS += framework/gui/WidgetAudioMessage.h
FORMS   += framework/gui/WidgetAudioMessage.ui

HEADERS += framework/gui/WidgetVariant.h

HEADERS += framework/gui/WidgetDataList.h

	HEADERS += framework/gui/WidgetFileSystemBrowser.h

HEADERS += framework/gui/WidgetFileSelector.h
FORMS   += framework/gui/WidgetFileSelector.ui

HEADERS += framework/gui/WidgetMediaList.h
FORMS   += framework/gui/WidgetMediaList.ui

HEADERS += framework/gui/WidgetMediaZone.h
FORMS   += framework/gui/WidgetMediaZone.ui

HEADERS += framework/gui/WidgetMethods.h
SOURCES += framework/gui/WidgetMethods.cpp
FORMS   += framework/gui/WidgetMethods.ui

HEADERS += framework/gui/WidgetMethodCaller.h
SOURCES += framework/gui/WidgetMethodCaller.cpp
FORMS   += framework/gui/WidgetMethodCaller.ui

HEADERS += framework/gui/WidgetNotification.h
FORMS   += framework/gui/WidgetNotification.ui

HEADERS += framework/gui/WidgetProperties.h
SOURCES += framework/gui/WidgetProperties.cpp
FORMS   += framework/gui/WidgetProperties.ui

HEADERS += framework/gui/WidgetQMenu.h
SOURCES += framework/gui/WidgetQMenu.cpp

HEADERS += framework/gui/WidgetSystemError.h
FORMS   += framework/gui/WidgetSystemError.ui

HEADERS += framework/gui/WidgetTextMessage.h
FORMS   += framework/gui/WidgetTextMessage.ui

HEADERS += framework/gui/WidgetUpdateBar.h
SOURCES += framework/gui/WidgetUpdateBar.cpp
FORMS   += framework/gui/WidgetUpdateBar.ui

HEADERS += framework/gui/WidgetUriSelector.h
FORMS   += framework/gui/WidgetUriSelector.ui

HEADERS += framework/gui/WidgetUser.h
FORMS   += framework/gui/WidgetUser.ui

HEADERS += framework/gui/WidgetWoshBrowser.h
SOURCES += framework/gui/WidgetWoshBrowser.cpp
FORMS   += framework/gui/WidgetWoshBrowser.ui

#####

HEADERS += framework/gui/WoshObject.h

HEADERS += framework/gui/WoshObjectTreeModel.h
SOURCES += framework/gui/WoshObjectTreeModel.cpp

HEADERS += framework/gui/WoshTableModel.h



!include( framework/gui/modules/modules.pro ) {
	message( "*****  No framework/gui/modules/modules.pro file found. *****" )
	message( "*****  FAILED *****" )
}

!include( framework/gui/bundles/bundles.pro ) {
	message( "*****  No framework/gui/bundles/bundles.pro file found. *****" )
	message( "*****  FAILED *****" )
}


WOSH_KIOSK {
	!include( framework/gui/kiosk/kiosk.pro ) {
		message( "*****  No framework/gui/kiosk/kiosk.pro file found. *****" )
		message( "*****  FAILED *****" )
	}
}


