/**
 * @class   wosh::gui::DialogProgress
 * @brief   
 *          
 *          
 *
 ****************************************************************************
 * @version $Id: DialogProgress.h 1737 2010-01-28 16:39:26Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/
 
#ifndef __WOSH_Gui_DialogProgress_H__
 #define __WOSH_Gui_DialogProgress_H__

 #include <QtGui/QGroupBox>
 #include "ui_DialogProgress.h"



using namespace std;
namespace wosh {
 namespace gui {


class DialogProgress : public QGroupBox {

	Q_OBJECT

	public:
		DialogProgress(QWidget *parent = 0) : QGroupBox(parent) {
			this->m_ui = new Ui::DialogProgress();
			this->m_ui->setupUi(this);
i = 0;
			connect(this->m_ui->pushButton, SIGNAL(clicked()), this, SLOT(clicked()));
		 }

		virtual ~DialogProgress() {
			delete this->m_ui;
		 }




	public slots:

		void clicked() {
			this->m_ui->pushButton->setText( QString("clicked %1").arg(++i) );
		 }

		void setTitleText( const QString& text ) {
			this->m_ui->lblDialogTitle->setText(text);
		 }

		void setProgressText( const QString& text ) {
			this->m_ui->lblDialogProgress->setText(text);
		 }

		void setProgressValue( int value ) {
			this->m_ui->progressBarDialog->setValue(value);
		 }

		void setProgress( int value, const QString& text ) {
			setProgressValue(value);
			setProgressText(text);
		 }


	private:
		Ui::DialogProgress *m_ui;

		int i;

}; // class def

 }; // namespace gui
}; // namespace wosh


#endif //__WOSH_Gui_DialogProgress_H__
