/**
 * @class   wosh::gui::GadgetMusic
 * @brief   
 *
 *
 ****************************************************************************
 * @version $Id: GadgetMusic.h 1690 2010-01-25 05:19:57Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Gui_GadgetMusic_H__
 #define __WOSH_Gui_GadgetMusic_H__

 #include <framework/gui/kiosk/KioskGadget.h>


using namespace wosh;
namespace Ui {
 class GadgetMusic;
};
using namespace std;
namespace wosh {
 namespace gui {

 #define _GadgetMusic_TYPE	"wosh::application::GadgetMusic"


class GadgetMusic : public KioskGadgetGeneric  {

	Q_OBJECT

	public:
		/**
		 * @brief  Empty constructor.
		 */
		GadgetMusic();
		/**
		 * @brief  Empty destructor.
		 */
		virtual ~GadgetMusic();


	public slots:
		virtual void refreshAll();

	public:
		void busMessage( const Message& message, const Bus* source );

	private:
		Ui::GadgetMusic *m_ui;


}; // class def

  }; // namespace gui
}; // namespace wosh

#endif //__WOSH_Gui_GadgetMusic_H__

