/** @file    GadgetStatus.cpp
 *  @author  Alessandro Polo
 *  @version $Id: GadgetStatus.cpp 226 2009-04-28 05:47:50Z alex $
 *  @brief
 * File containing methods for the wosh::gui::GadgetStatus class.
 * The header for this class can be found in GadgetStatus.h, check that file
 * for class description.
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/
 
 #include "GadgetStatus.h"
 #include "ui_GadgetStatus.h"


namespace wosh {
  namespace gui {

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////// CONSTRUCTORS

GadgetStatus::GadgetStatus() : KioskGadgetGeneric()
 {
	this->m_ui = new Ui::GadgetStatus();
	this->m_ui->setupUi(this);

//	Object::setName("GadgetStatus");
//	Object::setType(_GadgetStatus_TYPE);
	KioskGadgetGeneric::setTitle(tr("Status"));

	this->m_ui->lblSystemStatus->setText("BOH");
	this->m_ui->lblConnectionStatus->setText("BOH");
	this->m_ui->lblNetworkStatus->setText("BOH");

	connect(this->m_ui->btnSheetDebug, SIGNAL(clicked()), this, SLOT(btnSheetDebug_clicked()));

 }

GadgetStatus::~GadgetStatus()
 {
	delete this->m_ui;
 }

//////////////////////////////////////////////////////////////////////////////////////////////// CONSTRUCTORS
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

void GadgetStatus::refreshAll() {

 }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////

void GadgetStatus::btnSheetDebug_clicked()
 {

 }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

void GadgetStatus::busMessage( const Message& message, const Bus* )
 {
	if ( message.isEmpty() ) return;
	if ( !message.getContent()->isResponse() ) return;
	if ( !isMessageForMeOrFromTarget(message) )
		return;
//	const wosh::Response* response = message.getContent()->asResponse();

	//this->propMapper->evalResponse(response);
 }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////////////////

  }; // namespace gui
}; // namespace wosh
