# QMAKE Properties file
# Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
# by Alessandro Polo - OpenSmartHome.com
# All rights reserved.
#######################################################
# Revision $Id: network.pro 2082 2010-03-11 06:26:42Z alex $
#######################################################

DEFINES += WOSH_NETWORK

!CONFIG(WOSH_NETWORK_QT) {
	!CONFIG(WOSH_NETWORK_LIBSOCKETS) {
		CONFIG += WOSH_NETWORK_QT
		message( "WOSH - FRAMEWORK [Network] (Unset, forced: Qt)" )
	}
}

#####################################################
#####################################################

WOSH_NETWORK_QT {
	DEFINES += WOSH_NETWORK_QT
	!include( framework/network/Qt/network.Qt.pro ) {
		error( "FATAL: Project file 'framework/network/Qt/network.Qt.pro' is missing! (disaligned distribution?)" )
	}
}

WOSH_NETWORK_LIBSOCKETS {
	DEFINES += WOSH_NETWORK_LIBSOCKETS
	!include( framework/network/libSockets/network.libSockets.pro ) {
		error( "FATAL: Project file 'framework/network/libSockets/network.libSockets.pro' is missing! (disaligned distribution?)" )
	}
}

#####################################################
#####################################################

SOURCES += framework/network/network_registration.cpp

#####################################################
# UDP Networking (socket interface)
#
HEADERS += framework/network/SocketUdp.h


#####################################################
# TCP Networking (sockets interface)
#
HEADERS += framework/network/ServerTcp.h
HEADERS += framework/network/SocketTcp.h


#####################################################
# Networking Utilities
# shared by all implementation (Qt, libSocket, ..)
#
HEADERS += framework/network/NetworkUtilities.h
SOURCES += framework/network/NetworkUtilities.cpp


#####################################################
# WOSH UDP Networking (channel, protocol)
#
# shared by all implementation (Qt, libSocket, ..)
#
HEADERS += framework/network/NetworkChannelUdp.h
SOURCES += framework/network/NetworkChannelUdp.cpp

HEADERS += framework/network/NetworkProtocolUdp.h
SOURCES += framework/network/NetworkProtocolUdp.cpp


#####################################################
#####################################################
# WOSH TCP Networking (channel, protocol)
#
HEADERS += framework/network/NetworkChannelTcpServer.h
SOURCES += framework/network/NetworkChannelTcpServer.cpp
HEADERS += framework/network/NetworkChannelTcp.h
SOURCES += framework/network/NetworkChannelTcp.cpp

HEADERS += framework/network/NetworkProtocolTcp.h
SOURCES += framework/network/NetworkProtocolTcp.cpp




##########################################################################################################
##########################################################################################################

HEADERS += framework/network/ClientHttp.h
SOURCES += framework/network/ClientHttp.cpp

##########################################################################################################
##########################################################################################################
##########################################################################################################
##########################################################################################################



#####################################################
# WOSH DBUS Networking (channel, protocol)
#
# CONFIG += qdbus
# HEADERS += framework/network/NetworkChannelDBus.h
# SOURCES += framework/network/NetworkChannelDBus.cpp
# HEADERS += framework/network/NetworkProtocolDBus.h
# SOURCES += framework/network/NetworkProtocolDBus.cpp


#####################################################
# WOSH SSL Networking (channel, protocol)
#
#HEADERS += framework/network/ChannelSslServer.h
#SOURCES += framework/network/ChannelSslServer.cpp
#HEADERS += framework/network/ChannelSslSocket.h
#SOURCES += framework/network/ChannelSslSocket.cpp
#HEADERS += framework/network/SocketSsl.h
#SOURCES += framework/network/SocketSsl.cpp
#HEADERS += framework/network/NetworkProtocolSsl.h
#SOURCES += framework/network/NetworkProtocolSsl.cpp


