/**
 * @class   wosh::EncoderReaderRaw
 * @brief   
 *
 ****************************************************************************
 * @version $Id: EncoderReaderRaw.h 1920 2010-02-22 13:42:51Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Persistence_EncoderRaw_H__
 #define __WOSH_Persistence_EncoderRaw_H__

 #include <woshDefs.h>
 #include <core/EncoderReader.h>
 #include <core/EncoderWriter.h>

// #include <iostream>
 #include <fstream>

namespace wosh {
 namespace persistence {


 #define _EncoderReaderRaw_TYPE					"wosh::persistence::EncoderReaderRaw"

class EncoderReaderRaw : public IEncoderReader  {

	public:
		/**
		 * @brief  Empty constructor.
		 */
		EncoderReaderRaw( const std::string& filename ) : IEncoderReader() {

			this->myfile.open( filename.c_str() );

		 }
		/**
		 * @brief  Empty destructor.
		 */
		virtual ~EncoderReaderRaw() {
			close();
		 }


		virtual void close() {
			if ( this->myfile.is_open() )
				this->myfile.close();
		 }

/** @name Getters
 * @{
 ******************************************************************************/
	public:

//@}
/** @name Setters
 * @{
 ******************************************************************************/
	public:

//@}

//		friend std::istream& operator>>( std::istream& i, wosh::EncoderReaderRaw& data );
//		friend std::ostream& operator<<( std::ostream& o, const wosh::EncoderReaderRaw& data );

	public:
		virtual WRESULT pop( std::string& obj, long size ) { // !!!
			if ( size == 0 )
				this->myfile >> obj;
			else if ( size == -1 ) {
				//this->myfile.
			//char* buffer = new 
			 }

return true;
		 }

		virtual WRESULT pop( char* data, long size ) {
			this->myfile.read(data, size);
return true;
		 }

/*
		template <typename T>
		WRESULT pop( T& obj ) {
			this->myfile >> obj;
			return true;
		 }
*/

		virtual WRESULT pop( int& obj ) {
			this->myfile >> obj;
			return true;
		 }
		virtual WRESULT pop( long& obj ) {
			this->myfile >> obj;
			return true;
		 }
		virtual WRESULT pop( double& obj ) {
			this->myfile >> obj;
			return true;
		 }
		virtual WRESULT pop( float& obj ) {
			this->myfile >> obj;
			return true;
		 }

	public:
		std::ifstream myfile;

}; // class def






 #define _EncoderWriterRaw_TYPE					"wosh::persistence::EncoderWriterRaw"

class EncoderWriterRaw : public IEncoderWriter  {
	public:
		EncoderWriterRaw( const std::string& filename ) : IEncoderWriter() {

			this->myfile.open( filename.c_str() );

		 }
		virtual ~EncoderWriterRaw() {
			close();
		 }


	public:
		virtual WRESULT push( const std::string& obj ) { // !!!
			this->myfile << obj << std::endl;
return true;
		 }

		virtual WRESULT push( const char* data, unsigned long size ) {
			this->myfile.write(data, size);
return false;
		 }

/*
		template <typename T>
		WRESULT pop( T& obj ) {
			this->myfile << obj;
			return true;
		 }
*/

		virtual WRESULT push( const int& obj ) {
			this->myfile << obj << std::endl;
			return true;
		 }
		virtual WRESULT push( const long& obj ) {
			this->myfile << obj << std::endl;
			return true;
		 }
		virtual WRESULT push( const double& obj ) {
			this->myfile << obj << std::endl;
			return true;
		 }
		virtual WRESULT push( const float& obj ) {
			this->myfile << obj << std::endl;
			return true;
		 }

		virtual void close() {
			if ( this->myfile.is_open() )
				this->myfile.close();
		 }

	public:
		virtual void setIndentLevel( short offset, bool reset = false ) {
			(void)offset; (void)reset;
		 }

	protected:


	protected:
		std::ofstream myfile;

}; // class def



/*


class MyClass1 : public virtual ISerializable  {
	public:
		WOSH_SERIALIZABLE(wosh::persistence::MyClass1)
		WOSH_COMPARE_RTTI(wosh::persistence::MyClass1)

	public:
		MyClass1() {
			this->int1 = 0;
			this->long1 = 1;
			this->double1 = 2.3;
			this->string1 = "ciao ciao";
		 }
		MyClass1( const wosh::persistence::MyClass1& ) { }	// because of WOSH_CLONE

		bool operator==(const wosh::persistence::MyClass1& ) const {	// because of WOSH_COMPARE_RTTI
			return false;
		 }

	public:
		virtual std::string toString() const { return ""; }

		virtual WRESULT store( IEncoderWriter* serializer ) const {
			if ( serializer == NULL ) return WRET_ERR_PARAM;
			serializer->push( this->int1 );
			serializer->push( this->long1 );
			serializer->push( this->double1 );
			serializer->push( this->string1 );
			return WRET_OK;
		 }

		virtual WRESULT retrieve( IEncoderReader* deserializer ) {
			if ( deserializer == NULL ) return WRET_ERR_PARAM;
			deserializer->pop( this->int1 );
			deserializer->pop( this->long1 );
			deserializer->pop( this->double1 );
			deserializer->pop( this->string1, -1 );
			return WRET_OK;
		 }

		int int1;
		long long1;
		double double1;
		std::string string1;

}; // class def


void test_enc_raw() {
	MyClass1 cl1;

	cl1.int1 = 30123;
	cl1.long1 = 60000;
	cl1.double1 = 54.4545;
	cl1.string1 = "MaoMao Mao $%&/space ";

	EncoderWriterRaw encW("prova.txt");
	cl1.store( &encW );
	encW.close();

	MyClass1 cl2;
	EncoderReaderRaw encR("prova.txt");
	cl2.retrieve( &encR );
	encR.close();


 }


void myTest() {

	MyClass1* cl1 = new MyClass1();
	MyClass1* cl11 = new MyClass1(*cl1);
	MyClass1* cl12 = cl1->clone();

	int equal_object = cl1->compare(cl11); (void)equal_object;
	bool same_class = cl1->isTypeOf<MyClass1>(); (void)same_class;
	bool same_class1 = cl1->isTypeOf<wosh::MyClass1>(); (void)same_class1;
	bool same_class2 = cl1->isClass( cl12->getClassName() ); (void)same_class2;


}

*/






 }; // namespace persistence
}; // namespace wosh

#endif //__WOSH_Persistence_EncoderRaw_H__
