/**
 * @class   wosh::EncoderWriterSql
 * @brief   
 *
 *
 *
 *
 *
 *
 ****************************************************************************
 * @version $Id: EncoderWriterSql.h 1920 2010-02-22 13:42:51Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Persistence_Qt_EncoderWriterSql_H__
 #define __WOSH_Persistence_Qt_EncoderWriterSql_H__

 #include <woshDefs.h>
 #include <core/EncoderWriter.h>

 #include <core/LogContext.h>



namespace wosh {
 namespace persistence {


 #define _EncoderWriterSql_TYPE					"wosh::persistence::EncoderWriterSql"

class EncoderWriterSql : public IEncoderWriter
 {

	public:

		EncoderWriterSql( );

		virtual ~EncoderWriterSql() {
			close();
		 }

	public:
		virtual WRESULT open( const std::string& filename);
		virtual WRESULT close();

	public:
		virtual WRESULT push( const std::string& obj, const std::string& field_name = "", SerializeStrategy strategy = SERIALIZE_DEFAULT );
		virtual WRESULT push( const int& obj, const std::string& field_name = "", SerializeStrategy strategy = SERIALIZE_DEFAULT );


/*
		virtual WRESULT push( const char* data, unsigned long size ) {
			this->myfile.write(data, size);
return false;
		 }

		template <typename T>
		WRESULT pop( T& obj ) {
			this->myfile << obj;
			return true;
		 }


		virtual WRESULT push( const int& obj ) {
			this->myfile << obj << std::endl;
			return true;
		 }
		virtual WRESULT push( const long& obj ) {
			this->myfile << obj << std::endl;
			return true;
		 }
		virtual WRESULT push( const double& obj ) {
			this->myfile << obj << std::endl;
			return true;
		 }
		virtual WRESULT push( const float& obj ) {
			this->myfile << obj << std::endl;
			return true;
		 }
*/

	public:
		virtual void setIndentLevel( short offset, bool reset = false ) {
			(void)offset; (void)reset;
		 }

	protected:

		wosh::LogContext Log;


	protected:


}; // class def



 }; // namespace persistence
}; // namespace wosh

#endif //__WOSH_Persistence_Qt_EncoderWriterSql_H__
