/**
 * @class   wosh::interfaces::devices::WindowsMobile
 * @brief   Standard interface of a generic WindowsMobile (device).
 *
 * @ingroup Interfaces
 ****************************************************************************
 * @version 1.00 $Id: WindowsMobile.h 2074 2010-03-10 02:38:16Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Interfaces_Devices_WindowsMobile_H__
 #define __WOSH_Interfaces_Devices_WindowsMobile_H__

 #include <interfaces/devices/Phone.h>


namespace wosh {
 namespace interfaces {
  namespace devices {

 #define _WindowsMobile_TYPE					"wosh::devices::WindowsMobile"

 #define _WindowsMobile_KEY_Manufacturer		"Manufacturer"
 #define _WindowsMobile_KEY_Model				"Model"
 #define _WindowsMobile_KEY_Revision			"Revision"
 #define _WindowsMobile_KEY_SerialNumber		"SerialNumber"
 #define _WindowsMobile_KEY_SubscriberNumber	"SubscriberNumber"
 #define _WindowsMobile_KEY_					""

 #define _WindowsMobile_METHOD_send_sms			"send_sms"
 #define _WindowsMobile_METHOD_fake_sms			"fake_sms"

 #define _WindowsMobile_METHOD_dial_call		"dial_call"
 #define _WindowsMobile_METHOD_udpdate_info		"udpdate"

 #define _WindowsMobile_METHOD_shutdown			"shutdown"


class WindowsMobile : public virtual Phone
 {
	WOSH_BUNDLE_INTERFACE("wosh::interfaces::devices::WindowsMobile")


	public:
		static const int AllowedOnSameKernel = -1;	///< There can be multiple (any) instances within a kernel
		static const int AllowedOnSameNetwork = -1;	///< There can be multiple (any) instances on the network



	public:
		virtual ~WindowsMobile() { }

}; // class def

  }; // namespace devices
 }; // namespace interfaces
}; // namespace wosh

#endif //__WOSH_Interfaces_Devices_WindowsMobile_H__
