/**
 * @file    interfaces/services.h
 * @brief   Include all interfaces of Service type
 ****************************************************************************
 * @namespace wosh::interfaces::services
 * @brief     Contains standard interfaces of services.
 *
 ****************************************************************************
 * \defgroup Services Services
 *
 * WOSH Service is a sub-class of a generic Bundle.
 *
 * Services are usually full multi-platform.
 * Service are usually singleton on an host
 * 
 ****************************************************************************
 * @version 0.45 $Id: services.h 1690 2010-01-25 05:19:57Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Interfaces_Services_H__
 #define __WOSH_Interfaces_Services_H__

 #include <woshDefs.h>

namespace wosh {
 namespace interfaces {
  namespace services { };
 };
};

 #include <interfaces/Service.h>

 #include <interfaces/services/Alarm.h>
 #include <interfaces/services/AutomationManager.h>
 #include <interfaces/services/BigBrother.h>
 #include <interfaces/services/BuildingManager.h>
 #include <interfaces/services/Butler.h>
 #include <interfaces/services/CommunicationManager.h>
 #include <interfaces/services/CommunicatorService.h>
 #include <interfaces/services/Cron.h>
 #include <interfaces/services/DesktopNotifier.h>
 #include <interfaces/services/Discovery.h>
 #include <interfaces/services/DiscoveryUdp.h>
 #include <interfaces/services/Festival.h>
 #include <interfaces/services/Heyu.h>
 #include <interfaces/services/HumanInterpreter.h>
 #include <interfaces/services/InterpreterService.h>
 #include <interfaces/services/Man.h>
 #include <interfaces/services/MediaDirector.h>
 #include <interfaces/services/Organizer.h>
 #include <interfaces/services/SessionServer.h>
 #include <interfaces/services/SystemServices.h>
 #include <interfaces/services/TelnetServer.h>
 #include <interfaces/services/Weather.h>



#endif //__WOSH_Interfaces_Services_H__
