/**
 * @class   wosh::interfaces::services::Heyu
 * @brief   Standard interface of Heyu (service).
 *
 * @ingroup Interfaces
 ****************************************************************************
 * @version 0.00 $Id: Heyu.h 2074 2010-03-10 02:38:16Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Interfaces_Services_Heyu_H__
 #define __WOSH_Interfaces_Services_Heyu_H__

 #include <interfaces/Service.h>


namespace wosh {
 namespace interfaces {
  namespace services {

 #define _Heyu_NAME						"Heyu"
 #define _Heyu_TYPE						"wosh::services::Heyu"

 #define _Heyu_KEY_HeyuBin				"HeyuBin"
 #define _Heyu_KEY_HeyuStatus			"HeyuStatus"
 #define _Heyu_KEY_HeyuVersion			"HeyuVersion"
 #define _Heyu_KEY_HeyuConfigFile		"HeyuConfigFile"
 #define _Heyu_KEY_HeyuPowerLineInt		"HeyuPowerLineInt"
 #define _Heyu_KEY_HeyuArmedState		"HeyuArmedState"

 #define _Heyu_KEY_BindAliasesAsName	"BindAliasesAsName"
 #define _Heyu_KEY_AutoReloadAliases	"AutoReloadAliases"
 #define _Heyu_KEY_RegisterAll			"RegisterAll"
 #define _Heyu_KEY_RefreshFrequency		"RefreshFrequency"


 #define _Heyu_METHOD_eval_cmd			"evalcmd"

 #define _Heyu_METHOD_update_cache		"update_cache"


class Heyu : public virtual Service
 {
	WOSH_BUNDLE_INTERFACE("wosh::interfaces::services::Heyu")


	public:
		virtual std::string getInterfaceName() const			{ return _Heyu_TYPE; }

		static const int AllowedOnSameKernel = 1;	///< Only one instance is allowed on same kernel
		static const int AllowedOnSameNetwork = -1;	///< There can be multiple (any) instances on the network



	public:
		virtual ~Heyu() { }

}; // class def

  }; // namespace services
 }; // namespace interfaces
}; // namespace wosh

#endif //__WOSH_Interfaces_Services_Heyu_H__
