/**
 * @class   wosh::interfaces::services::Man
 * @brief   Standard interface of Man (service).
 *
 * @ingroup Interfaces
 ****************************************************************************
 * @version 0.00 $Id: Man.h 2074 2010-03-10 02:38:16Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Interfaces_Services_Man_H__
 #define __WOSH_Interfaces_Services_Man_H__

 #include <interfaces/Service.h>


namespace wosh {
 namespace interfaces {
  namespace services {

 #define _Man_NAME					"Man"
 #define _Man_TYPE					"wosh::services::Man"

 #define _Man_KEY_XmlFolder			"XmlFolder"
 #define _Man_KEY_XslFolder			"XslFolder"
 #define _Man_KEY_TmpFolder			"TmpFolder"

 #define _Man_METHOD_flush			"flush"
 #define _Man_METHOD_regenerate		"regenerate"


class Man : public virtual Service
 {
	WOSH_BUNDLE_INTERFACE("wosh::interfaces::services::Man")


	public:
		virtual std::string getInterfaceName() const			{ return _Man_TYPE; }

		static const int AllowedOnSameKernel = 1;	///< Only one instance is allowed on same kernel
		static const int AllowedOnSameNetwork = -1;	///< There can be multiple (any) instances on the network


	public:
		virtual ~Man() { }

}; // class def

  }; // namespace services
 }; // namespace interfaces
}; // namespace wosh

#endif //__WOSH_Interfaces_Services_Man_H__
