/**
 * @class   wosh::services::ServiceStandaloneBundle
 * @brief   Manager of Building Objects (such as Floor, Room and other
 *          types from wosh::building namespace).
 *
 *
 *
 *
 * @ingroup Services
 ****************************************************************************
 * @version $Id: ServiceStandaloneBundle.h 1945 2010-02-24 23:13:14Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Bundles_Services_ServiceStandalone_H__
 #define __WOSH_Bundles_Services_ServiceStandalone_H__

 #include <core/BundleGeneric.h>

 #include <interfaces/Service.h>
 #include <interfaces/services/ServiceStandalone.h>


using namespace std;
namespace wosh {
 namespace services {

 #define _ServiceStandalone_VERSION				"0.0"


class ServiceStandaloneBundle :	public BundleGeneric,
								public virtual wosh::interfaces::Service,
								public virtual wosh::interfaces::services::ServiceStandalone
 {
	WOSH_BUNDLE(wosh::services::ServiceStandaloneBundle)

	public:

		ServiceStandaloneBundle();

		virtual ~ServiceStandaloneBundle();


/** @name Bundle Interface
 * @{
 ******************************************************************************/
	public:
		virtual WRESULT bundleStart();
		virtual WRESULT bundleStop();

		virtual void busMessage( const Message& message, const Bus* source );

		// don't override my URI!
		//virtual void setName( const std::string& value );

//@}
/** @name ServiceStandalone Interface
 * @{
 ******************************************************************************/
	public:


//@}
/** @name IPropertiesProviderListener interface
 * @{
 ******************************************************************************/
 	public:
		virtual bool readingProperty( Property* property_curr, const PropertiesProvider* source );
		virtual bool updatingProperty( Property* property_new, const Property* property_old, const PropertiesProvider* source );
//@}
/** @name Internal methods
 * @{
 ******************************************************************************/
	protected:

	protected:

//@}
	protected:



}; // class def

 }; // namespace services
}; // namespace wosh

#endif //__WOSH_Bundles_Services_ServiceStandalone_H__
