/**
 * @class   wosh::services::ServiceWithWorkerBundle
 * @brief   
 *
 *
 *
 *
 *
 * @ingroup Services
 * @see     wosh::NetworkManager
 * @see     wosh::WoshHost
 * @see     wosh::services::ServiceWithWorker
 ****************************************************************************
 * @version $Id: ServiceWithWorkerBundle.h 1945 2010-02-24 23:13:14Z alex $
 * @author  Alessandro Polo
 * @date    Released on 2009-06-04
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ****************************************************************************/

#ifndef __WOSH_Bundles_Services_ServiceWithWorker_H__
 #define __WOSH_Bundles_Services_ServiceWithWorker_H__

 #include <core/BundleGeneric.h>
 #include <core/Thread.h>

 #include <interfaces/Service.h>
 #include <interfaces/services/ServiceWithWorker.h>

class ServiceWithWorkerWorker;

using namespace std;
namespace wosh {
 namespace services {

 #define _ServiceWithWorker_VERSION							0.00


class ServiceWithWorkerBundle :	public BundleGeneric,
								public virtual wosh::interfaces::Service,
								public virtual wosh::interfaces::services::ServiceWithWorker
 {
	WOSH_BUNDLE(wosh::services::ServiceWithWorkerBundle)

	public:

		/**
		 * @brief   Empty constructor, init bundle and vars, Properties and Methods.
		 */
		ServiceWithWorkerBundle();

		/**
		 * @brief   Empty destructor, may (synch) stop bundle and internal threads when still running
		 */
		virtual ~ServiceWithWorkerBundle();


/** @name Bundle Interface
 * @{
 ******************************************************************************/
	public:

		/**
		 * @brief   Start the internal thread (used for refreshing stats).
		 * @see    BundleGeneric::bundleStart()
		 */
		virtual WRESULT bundleStart();

		/**
		 * @brief   Stop the internal thread (used for refreshing stats).
		 * @see    BundleGeneric::bundleStop()
		 */
		virtual WRESULT bundleStop();

		virtual void busMessage( const Message& message, const Bus* source );
//@}
/** @name Getters
 * @{
 ******************************************************************************/
 	public:

//@}
/** @name Setters
 * @{
 ******************************************************************************/
 	public:
		bool updatingProperty( Property* property_new, const Property* property_old, const PropertiesProvider* source );

//@}
/** @name Internal methods
 * @{
 ******************************************************************************/
	protected:

//@}
	protected:

		ServiceWithWorkerWorker* myWorker;		///< real implementation

}; // class def

 }; // namespace services
}; // namespace wosh

#endif //__WOSH_Bundles_Services_ServiceWithWorker_H__
