/**
 * @file    test_DSM.cpp
 * @brief   Test classes: wosh::Property, wosh::PropertiesProvider
 *          Indirectly tests also wosh::Variant
 *
 * @version $Id: test_DSM.cpp 2067 2010-03-09 23:40:30Z alex $
 * @author  Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************/

 #include "test_DSM.h"
 #include <woshDefs.h>
 #include <core/LogContext.h>
 #include <core/Utilities.h>
 #include <core/BusRing.h>


using namespace wosh;

void real_test(SharedMemory* ts1, SharedMemory* ts2);

int test_DSM()
 {
	log(LOG_INFO, "test_DSM()", "Starting TEST" );

	BusRing dsmBus("wosh.Bus.DSM");
	dsmBus.startBus();

	SharedMemory* ts1 = new SharedMemory("tuplespace1");
	SharedMemory* ts2 = new SharedMemory("tuplespace1");
	ts1->BusDSM.setBus(&dsmBus);
	ts2->BusDSM.setBus(&dsmBus);
	dsmBus.addBusListener(ts1);
	dsmBus.addBusListener(ts2);
	//-----------
	createDataSet(ts1);
	//-----------

real_test(ts1, ts2);

	//-----------
	dsmBus.removeBusListener(ts2);
	delete ts2;
	dsmBus.removeBusListener(ts1);
	delete ts1;

	log(LOG_INFO, "test_DSM()", "Finished TEST" );
	return 0;
 }

 
int main() {

	test_DSM();
	return 0;
}

void createDataSet( wosh::SharedMemory* dsm ) {
	dsm->getDataSet().set("name1", new TestSharedObject("obj1", "123"));
	dsm->getDataSet().set("name3", new TestSharedObject("obj3", "789"));
	dsm->getDataSet().set("name2", new TestSharedObject("obj2", "456"));
 }

///_------------------------------------------------------------------------------------------


void real_test(SharedMemory* ts1, SharedMemory* ts2) {

	// force a TOTAL (re)synchronization = Init?

	// AGAINST WHO(role)?? WHAT IS MY ROLE?

	ts2->invalidate(); // invalidate status and whole dataset (nested)

//	ts2->update(); // perform required operation to be synch




}
