/**
 * @file    test_Utilities.h
 * @brief   
 * @version	$Id: test_Utilities.h 1499 2009-12-31 16:39:34Z alex $
 * @author	Alessandro Polo
 ****************************************************************************/
/* Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
 * by Alessandro Polo - OpenSmartHome.com
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSmartHome.com WOSH nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Alessandro Polo ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL Alessandro Polo BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************/


int test_Utilities();

void test_Conversions() {

	int vInteger; double vDouble; float vFloat; bool vBool; std::string vString;

	vInteger = Utilities::fromString<int>("", 121);
	vInteger = Utilities::fromString<int>("asd", 121);
	vInteger = Utilities::fromString<int>("126", 122);
	vInteger = Utilities::fromString<int>("asdasd", 123);
	vInteger = Utilities::fromString<int>("0xA356", 124, std::hex);
	vInteger = Utilities::fromString<int>("0xA356", 125, std::dec);//bug

	vDouble = Utilities::fromString<double>("126.126", 125.126, std::dec);
	vDouble = Utilities::fromString<double>("0xA356", 125.127, std::hex);

	vFloat = Utilities::fromString<float>("128.128", 128.129, std::dec);
	vFloat = Utilities::fromString<float>("129.129", 128.129, std::hex);

	vBool = Utilities::fromString<bool>("true", false);
	vBool = Utilities::fromString<bool>("tr", false);
	vBool = Utilities::fromString<bool>("", true);
	vBool = Utilities::fromString<bool>("0", true);
	vBool = Utilities::fromString<bool>("5", false);

	string strrrss;
	strrrss = Utilities::fromString<std::string>("succedded", "FAILED", std::nouppercase);
	strrrss = Utilities::fromString<std::string>("SUCCEEDED", "failed", std::uppercase);
	strrrss = Utilities::fromString<std::string>("    <==== succeded ", "  =>FAILED ", std::left );
	strrrss = Utilities::fromString<std::string>(" succeded ====> ", " FAILED=>   ", std::right );

	strrrss = Utilities::fromString<std::string>("  Su cc ee d e d  ", " F A I L E D ", std::skipws );


 }

void test_PropertiesProvider();


