# QMAKE Configuration file
# Copyright (c) 2007-2010, WOSH - Wide Open Smart Home 
# by Alessandro Polo - OpenSmartHome.com
# All rights reserved.
#######################################################
# Revision $Id: woshsrv.pro 2186 2010-03-21 01:50:49Z alex $
#######################################################

message( "WOSH Server (multi-platform)" )

#####################################################
# generic configuration options
# woshsrv is a console application
#
CONFIG += console
TEMPLATE = app
TARGET = woshsrv


#####################################################
# set namespaces of the WOSH Framework to build-in
#
CONFIG += DB_SQL
#CONFIG += WOSH_AI
CONFIG += WOSH_AUTOMATIONS
CONFIG += WOSH_BUILDING
CONFIG += WOSH_COMMUNICATION
CONFIG += WOSH_ENTERTAINMENT
CONFIG += WOSH_PLUGINS
CONFIG += WOSH_SECURITY

#####################################################
CONFIG += WOSH_NETWORK_QT
#CONFIG += WOSH_NETWORK_LIBSOCKETS
#####################################################
#CONFIG += WOSH_DATABASE_QT
#CONFIG += WOSH_DATABASE_libxml2
#####################################################


#####################################################
# include core and interfaces, see
# framework/framework.pro for options, many
# namespaces are disabled by default
#
!include( common.pri ) {
	error( "FATAL: Project file 'common.pri' is missing! (disaligned distribution?)" )
}
#####################################################
# include WOSH Framework, framework options must be
# configured before following command.
#
!include( framework/framework.pro ) {
	error( "FATAL: Project file 'framework/framework.pro' is missing! (disaligned distribution?)" )
}
#####################################################
# include bundles, to include/exclude a bundle, 
# customize project files bundles\devices\devices.pri
# and bundles\services\services.pri
#
!include( bundles/bundles.pro ) {
	error( "FATAL: Project file 'bundles/bundles.pro' is missing! (disaligned distribution?)" )
} 

#####################################################
# include application's core file
#
SOURCES += apps/woshsrv/woshsrv.cpp

